-- module_drowning.lua: Drowning for SRTT/SRIV/SRGOOH [nclok1405]

-- Main Thread
-- Run it by `thread_new("drowning_main_thread")` from sr3_city_main()
function drowning_main_thread()
	local is_gooh = false	-- Assume Steelport duology by default
	local wait_for_respawn_from_lava = { [LOCAL_PLAYER] = 0, [REMOTE_PLAYER] = 0 }	-- Invincibility timer against lava

	-- If max notoriety is 6...
	if MAX_NOTORIETY_LEVEL == 6 then
		-- ...and there is a function named "character_is_in_lava", then we're in SRGOOH
		for func, v in pairs(_G) do
			if func == "character_is_in_lava" then
				is_gooh = true
				break
			end
		end
	end

	-- Wait until the loading screen goes away
	fade_in_block()

	-- Main Loop
	while true do
		thread_yield()

		if not is_gooh then
			-- Steelport duology

			-- If the player is swimming, kill him/her
			if character_is_swimming(LOCAL_PLAYER) then
				character_kill(LOCAL_PLAYER)
			end
			if coop_is_active() and character_is_swimming(REMOTE_PLAYER) then
				character_kill(REMOTE_PLAYER)
			end
			if (not character_is_dead("#FOLLOWER1#")) and character_is_swimming("#FOLLOWER1#") then
				character_disable_revival("#FOLLOWER1#", true)
				character_kill("#FOLLOWER1#")
			end
			if (not character_is_dead("#FOLLOWER2#")) and character_is_swimming("#FOLLOWER2#") then
				character_disable_revival("#FOLLOWER2#", true)
				character_kill("#FOLLOWER2#")
			end
			if (not character_is_dead("#FOLLOWER3#")) and character_is_swimming("#FOLLOWER3#") then
				character_disable_revival("#FOLLOWER3#", true)
				character_kill("#FOLLOWER3#")
			end
		else
			-- SRGOOH

			-- After respawning from a lava death, character_is_in_lava(player) returns true for a few frames.
			-- We make players invincible against lava for a few frames, otherwise they die again instantly on respawning.

			if (wait_for_respawn_from_lava[LOCAL_PLAYER] <= 0) and character_is_in_lava(LOCAL_PLAYER) then
				character_kill(LOCAL_PLAYER)
				wait_for_respawn_from_lava[LOCAL_PLAYER] = 0.2
			elseif (wait_for_respawn_from_lava[LOCAL_PLAYER] > 0) and (not character_is_dead(LOCAL_PLAYER)) then
				wait_for_respawn_from_lava[LOCAL_PLAYER] = wait_for_respawn_from_lava[LOCAL_PLAYER] - get_frame_time()
			end

			if coop_is_active() then
				if (wait_for_respawn_from_lava[REMOTE_PLAYER] <= 0) and character_is_in_lava(REMOTE_PLAYER) then
					character_kill(REMOTE_PLAYER)
					wait_for_respawn_from_lava[REMOTE_PLAYER] = 0.2
				elseif (wait_for_respawn_from_lava[REMOTE_PLAYER] > 0) and (not character_is_dead(REMOTE_PLAYER)) then
					wait_for_respawn_from_lava[REMOTE_PLAYER] = wait_for_respawn_from_lava[REMOTE_PLAYER] - get_frame_time()
				end
			end

			if (not character_is_dead("#FOLLOWER1#")) and character_is_in_lava("#FOLLOWER1#") then
				character_disable_revival("#FOLLOWER1#", true)
				character_kill("#FOLLOWER1#")
			end
			if (not character_is_dead("#FOLLOWER2#")) and character_is_in_lava("#FOLLOWER2#") then
				character_disable_revival("#FOLLOWER2#", true)
				character_kill("#FOLLOWER2#")
			end
			if (not character_is_dead("#FOLLOWER3#")) and character_is_in_lava("#FOLLOWER3#") then
				character_disable_revival("#FOLLOWER3#", true)
				character_kill("#FOLLOWER3#")
			end

		end
	end
end
